//---------------------------------------------------------------------------

#include <vcl.h>

#ifndef eqH
#define eqH
//---------------------------------------------------------------------------

enum { GROUP = 0, LITERAL, VARIABLE, SYMBOL };
enum { MAXPTR = 256, MAXNAME = 8 };
enum { ADD = 0, SUB, MUL, DIV, EXP, SQRT };
enum { T_LITERAL = 0, T_OPERATOR, T_NAME };

class Eq
{
  public:
    Eq();
    void Parse(const char *str);
    void DumpGroups(const char *str);
    void PrettyPrint(Graphics::TBitmap *b);

  private:
    struct Member
    {
      int type,
          ptr;      
    };
    struct Group
    {
      int    type;
      Member left,
             right;
    };
    struct Variable
    {
      char name[MAXNAME + 1];
    };
    struct Symbol
    {
      char name[MAXNAME + 1];
      int val;
    };

    void Error(const char *msg);
    int AddGroup();
    int AddLiteral(const int value);
    int AddVariable(const char *name);
    int Priority(const int type);
    int GetType(const char c);
    int GetTok(const char *str, int &p, char *buf, int &ptr, char &c);
    Member DoParse(const char *str, int &p,
                    const int l_prior, const Member l_member);

    Group     _group[MAXPTR];
    int       _literal[MAXPTR];
    Variable  _variable[MAXPTR];
    Symbol    _symbol[MAXPTR];
    int       _groups,
              _literals,
              _variables,
              _symbols;
};


#endif
